<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
    <style>
        .layui-input, .layui-select, .layui-textarea {height: 30px;}
    </style>
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline layui-form">
                            <select id="modelCategory" name="modelCategory" lay-filter="modelCategoryFilter">
                                <option value="">选择模型类别</option>
                                <option th:each="modelCategory:${modelCategories}" th:value="${modelCategory}" th:text="${modelCategory}"></option>
                            </select>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var form = layui.form;
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;
        var tableUrl = 'api/activiti/listpage';

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field:'name', width:150, title: '模型名称',  align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field:'modelCategory', width:150, title: '模型类别',  align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field:'key', width:150, title: '模型key',  align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field:'version', width:80, title: '版本',  align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field:'deploymentId', width:120, title: '部署ID',  align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field:'deploymentStatus', width:80, title: '状态', align:'center',
                            templet: function(row) {
                                if(!row.deploymentId) {
                                    return '<span class="layui-badge layui-bg-gray">未部署</span>';
                                } else {
                                    return '<span class="layui-badge layui-bg-green">已部署</span>';
                                }
                            }
                        },
                        {field:'createTime', width:180, title: '创建时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(!rowData) {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field:'lastUpdateTime', width:180, title: '最后更新时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(!rowData) {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'option', width: 80, title: '流程图', align:'center',
                            templet: function(row) {
                                if(!row.deploymentId) {
                                    return '-';
                                }
                                var flowChatImg = '<img id="flowChat'+ row.id +'" src="route/activiti/model/get-process-image/'+ row.deploymentId +'" style="width: 30px; height: 30px;"/>'
                                setTimeout(function() {
                                    new Viewer(document.getElementById('flowChat'+ row.id));
                                }, 50);
                                return flowChatImg;
                            }
                        },
                        {field: 'option2', width: 140, title: '操作', align:'center', fixed: 'right',
                            templet: function(row) {
                                return '<div class="layui-btn-group">' +
                                    '<button class="layui-btn layui-btn-normal layui-btn-xs" lay-event="deployEvent">部署</button>' +
                                    '<button class="layui-btn layui-btn-primary layui-btn-xs" lay-event="updateEvent">编辑</button>' +
                                    '<button class="layui-btn layui-btn-danger layui-btn-xs" lay-event="removeEvent">删除</button>' +
                                    '</div>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    modelCategory: $('#modelCategory').val()
                },
                page: {
                    curr: currentPage
                },
            });
        }
        initTable();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });

        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/activiti/save', []),
                    title: '新增流程图',
                    width: '400px',
                    height: '350px',
                    onClose: function() {
                        window.location.reload();
                    }
                });
            }
        });

        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var layEvent = obj.event;
            if(layEvent === 'deployEvent') {
                top.dialog.confirm('确定 部署 流程？', function(index) {
                    top.dialog.close(index);
                    var loadLayerIndex;
                    top.restAjax.put(top.restAjax.path('api/activiti/deploy/{modelId}', [data.id]), {}, null, function(code, data) {
                        top.dialog.msg('操作成功');
                        reloadTable();
                    }, function(code, data) {
                        top.dialog.msg(data.msg);
                    }, function() {
                        loadLayerIndex = top.dialog.msg(top.dataMessage.committing, {icon: 16, time: 0, shade: 0.3});
                    }, function() {
                        top.dialog.close(loadLayerIndex);
                    });
                });
            } else if(layEvent === 'updateEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/activiti/update?modelId={modelId}', [data.id]),
                    title: false,
                    width: '90%',
                    height: '90%',
                    onClose: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'removeEvent') {
                top.dialog.msg(top.dataMessage.delete, {
                    time: 0,
                    btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                    shade: 0.3,
                    yes: function (index) {
                        top.dialog.close(index);
                        var layIndex;
                        top.restAjax.delete(top.restAjax.path('api/activiti/model/delete/{id}', [data.id]), {}, null, function (code, data) {
                            top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                            reloadTable();
                        }, function (code, data) {
                            top.dialog.msg(data.msg);
                        }, function () {
                            layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                        }, function () {
                            top.dialog.close(layIndex);
                        });
                    }
                });
            }
        });
    });
</script>
</body>
</html>